<template>
  <main>
    <div style="margin-bottom;: 60px">
      <RouterLink to="/"
        ><span v-html="UNICODE.BACK"></span>&nbsp;Back to Search</RouterLink
      >
    </div>
    <h1>Search Results for &ldquo;{{ searchTerm }}&rdquo;</h1>
    <div v-if="!searchResults || !searchResults.length">No result found</div>
    <div v-else>
      {{ numFound }} results found{{
        numFound && numFound > 10 ? ', displaying top 10' : ''
      }}
    </div>
    <div class="book-box" v-for="(book, i) in searchResults" :key="i">
      <div class="cover">
        <object
          :data="`https://covers.openlibrary.org/b/olid/${book.cover_edition_key}-S.jpg?default=false`"
          type="image/jpeg"
        >
          <img src="@/assets/img/cover404.png" style="width: 36px" />
        </object>
      </div>
      <div class="text">
        <h3>{{ book.title }}</h3>
        <p>
          <strong>Author{{ book.author_name?.length > 1 ? 's' : '' }}:</strong>
          {{ book.author_name?.join(', ') }}
        </p>
        <p>
          <strong>Published:</strong>
          {{ book.first_publish_year }} by {{ book.publisher?.[0] }}
        </p>
      </div>
      <div class="details">
        <button class="details-button" @click="showDetailsDialog(book)">
          View Details
        </button>
      </div>
    </div>
    <ModalDialog :dialog="showDialog" @close="showDialog = false">
      <BookDetails />
    </ModalDialog>
  </main>
</template>

<script setup lang="ts">
import { ref, computed, onMounted } from 'vue'
import type { Book } from '@/types/book'
import { UNICODE } from '@/utils/constants'
import { useLoaderStore } from '@/stores/loader'
import { useSearchStore } from '@/stores/search'
import BookDetails from '@/components/BookDetails.vue'
import ModalDialog from '@/components/dialogs/ModalDialog.vue'

const showDialog = ref(false)

const loader = useLoaderStore()
onMounted(() => {
  loader.hide()
})

const searchStore = useSearchStore()
const { searchResults } = searchStore
const searchTerm = computed(() => searchStore.searchTerm)
const numFound = computed(() => searchStore.numFound)

const showDetailsDialog = (book: Book): void => {
  searchStore.currentBook = book
  showDialog.value = true
}
</script>

<style scoped>
main {
  width: 90%;
  height: 90%;
}
button {
  width: 100px;
  margin-top: 20px;
}
.book-box {
  display: flex;
  flex-direction: column;
  border-bottom: 1px solid #8884;
  padding: 10px 0;
}
.cover {
  flex: 0 0 60px;
}
.text {
  flex: 0 0 80%;
  padding-right: 20px;
}
@media screen and (min-width: 768px) {
  main {
    width: 60%;
  }
  .book-box {
    flex-direction: row;
  }
  button {
    margin-top: 0;
  }
}
</style>
